-- ----------------------------------------------------------------
-- counter_altera.vhd
--
-- 9/28/2010 D. W. Hawkins (dwh@ovro.caltech.edu)
--
-- Altera implementation of the counter component.
--
-- ----------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

-- Altera LPM components
library lpm;
use lpm.lpm_components.all;

-- ----------------------------------------------------------------

entity counter_altera is
	generic (
		-- Component parameters
		WIDTH     : integer;
		DIRECTION : string
	);
	port (
		rst   : in  std_logic;
		clk   : in  std_logic;
		clr   : in  std_logic;
		load  : in  std_logic;
		en    : in  std_logic;
		d     : in  std_logic_vector(WIDTH-1 downto 0);
		q     : out std_logic_vector(WIDTH-1 downto 0);
		cout  : out std_logic
	);
end entity;

-- ----------------------------------------------------------------

architecture structure of counter_altera is

begin

	u1: lpm_counter
		generic map (
			LPM_WIDTH     => WIDTH,
			LPM_DIRECTION => DIRECTION
		)
		port map (
			aclr   => rst,
			clock  => clk,
			sclr   => clr,
			sload  => load,
			cnt_en => en,
			data   => d,
			q      => q,
			cout   => cout
		);

end architecture;